﻿'2011 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net

Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports System.Runtime.Serialization
Imports System.ServiceModel.Description
Imports ServiceModelEx

<DataContract>
Friend Class Contact
   <DataMember>
   Public Property FirstName() As String

   <DataMember>
   Public Property LastName() As String
End Class

<DataContract>
Friend Class Customer
	Inherits Contact
   <DataMember>
   Public Property CustomerNumber() As Integer
End Class

<DataContract>
Friend Class Person
	Inherits Contact
   <DataMember>
   Public Property FavoritColor() As String
End Class



<DataContract>
Friend Class ContactA
	Inherits Contact
   <DataMember>
   Public Property Something() As String
End Class


<DataContract>
Friend Class ContactB
	Inherits ContactA
   <DataMember>
   Public Property SomethingElse() As String
End Class

<DataContract>
Friend Class ContainerClass
   <DataContract>
   Public Class NestedClass
	   Inherits Contact
	  <DataMember>
	  Public Property Something() As String
   End Class
End Class


<ServiceContract>
Friend Interface IContactManager
   <OperationContract>
   Sub AddContact(ByVal contact As Contact)

   <OperationContract>
   Function GetContacts() As Contact()
End Interface

Friend Class ContactManagerClient
	Inherits ClientBase(Of IContactManager)
	Implements IContactManager
   Public Sub AddContact(ByVal contact As Contact) Implements IContactManager.AddContact
	  Channel.AddContact(contact)
   End Sub

   Public Function GetContacts() As Contact() Implements IContactManager.GetContacts
	  Return Channel.GetContacts()
   End Function
End Class

