﻿'2011 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net

Imports System.Collections.ObjectModel
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports System.ServiceModel.Description
Imports System.Reflection

Namespace ServiceModelEx
    <AttributeUsage(AttributeTargets.Class)>
    Public Class GenericResolverBehaviorAttribute
        Inherits Attribute
        Implements IServiceBehavior
        Private Sub AddBindingParameters(ByVal serviceDescription As ServiceDescription,
                                         ByVal serviceHostBase As ServiceHostBase,
                                         ByVal endpoints As Collection(Of ServiceEndpoint),
                                         ByVal bindingParameters As BindingParameterCollection) Implements IServiceBehavior.AddBindingParameters
        End Sub

        Private Sub ApplyDispatchBehavior(ByVal serviceDescription As ServiceDescription,
                                          ByVal serviceHostBase As ServiceHostBase) Implements IServiceBehavior.ApplyDispatchBehavior
        End Sub

        Private Sub Validate(ByVal serviceDescription As ServiceDescription, ByVal serviceHostBase As ServiceHostBase) Implements IServiceBehavior.Validate
            If Process.GetCurrentProcess().ProcessName = "w3wp" Then
                If System.Reflection.Assembly.GetEntryAssembly() Is Nothing Then
                    For Each [module] As ProcessModule In Process.GetCurrentProcess().Modules
                        If [module].ModuleName.StartsWith("App_Code.") AndAlso [module].ModuleName.EndsWith(".dll") Then
                            GenericResolverInstaller.CallingAssembly = System.Reflection.Assembly.LoadFrom([module].FileName)
                            Exit For
                        End If
                    Next [module]
                End If
            End If
            Dim host = TryCast(serviceHostBase, ServiceHost)
            host.AddGenericResolver()
        End Sub
    End Class
End Namespace